#include "BLEDevice.h"
#include "BLEScan.h"
//#include <Wire.h>
//#include <LiquidCrystal.h>
//LiquidCrystal lcd(0);
#include <FastLED.h>
#include <IRremote.h>
#include <Ticker.h>  //Call the ticker. H Library
#include <U8g2lib.h>
#ifdef U8X8_HAVE_HW_I2C
#include <Wire.h>
#endif
U8G2_SSD1306_128X32_UNIVISION_F_SW_I2C u8g2(U8G2_R0, /* clock=*/21, /* data=*/22, /* reset=*/U8X8_PIN_NONE);  // Adafruit Feather ESP8266/32u4 Boards + FeatherWing OLED
Ticker ticker;
#define RECV_PIN 19       //Infrared receiving pin
IRrecv irrecv(RECV_PIN);  //Definition of infrared remote control pin
decode_results results;   //Define infrared remote control function

CRGB leds[4];               //Bottom RGB light
CRGB RGBleds[6];            //Ultrasonic RGB lamp
CRGB myRGBcolor(0, 0, 0);   //Bottom RGB
CRGB myRGBcolor6(0, 0, 0);  //Ultrasonic RGB
BLEScan* pBLEScan = NULL;
// The remote service we wish to connect to.
static BLEUUID serviceUUID("6479571c-2e6d-4b34-abe9-c35116712345");  //Host service UUID
//static BLEUUID   serviceUUID("6479571c-2e6d-4b34-abe9-c351167d5be6");
static BLEUUID charUUID("826f072d-f87c-4ae6-a416-6ffdcaa02d73");
static BLEUUID SEND_UUID("a655223b-5f59-4794-ba1f-3e8a4f51da69");
static BLEUUID Warning_UUID("71d5a0ad-0f4c-49c4-856c-612d837c5f86");
static boolean doConnect = false;                        //Connection sign
static boolean connected = false;                        //Connection success flag
static boolean doSacn = true;                            //Scan flag
static BLERemoteCharacteristic* pRemoteCharacteristic;   //Characteristic value sent by handle
static BLERemoteCharacteristic* pRemoteCharacteristic2;  //Ultrasonic characteristic value
static BLERemoteCharacteristic* pRemoteCharacteristic3;  //Warning characteristic value
static BLEAdvertisedDevice* pServer;
//Arduino docs It is emphasized that volatile must be used in variable declaration in case of concurrent threads (such as interrupts)
volatile int pwm_value = 0;  //Low level duration --- interruption
volatile int prev_time = 0;  //Record ultrasonic time --- interruption
volatile int distance = 0;   //Ultrasonic distance
int Close_Flag = 0;          //Turn off task flag
int BLE_Close = 0;           //Bluetooth off flag
int Ce_shi_Flag = 0;         //Test program flag
static int IR_Flag = 88;     //Infrared remote control sign
int shock_Flag = 0;          //Vibration sign
char CloseData;              //Receive serial port data during test
static int L = 0;            //Number of switch light signs
int num_L = 0;               //Save the left light seeking value
int num_R = 0;               //Save the right light seeking value
int i = 0;
static int rgb = 0;   //Bottom RGB
static int rgb6 = 0;  //Ultrasonic RGB
const int leftgo_Pin = 12;
const int lefttrun_Pin = 13;
const int rightgo_Pin = 14;
const int righttrun_Pin = 15;
const int Photodiode_R = 34, Photodiode_L = 35;  //Light seeking pin
int Ultrasonic_Pin = 27, Button_pin = 18;        //Ultrasonic and switch key pins
int QTI_Max, QTI_L = 39, QTI_R = 36;             //Line patrol pin
static int state_L, state_N;                     //Infrared remote control data recording
char LU[10];                                     //Save ultrasonic distance data
std::string value;
BLEClient* pClient = NULL;
BLERemoteService* pRemoteService = NULL;
#define G4 392
#define A4 440
#define B4 494
#define C5 523
#define D5 587
#define E5 659
#define F5 698
#define G5 784
int Tone[] = { B4, B4, B4, B4, B4, B4,
               B4, D5, G4, A4, B4,
               C5, C5, C5, C5, C5, B4, B4, B4,
               D5, D5, C5, A4, G4, G5
             };
double Time[] = { 0.25, 0.25, 0.5, 0.25, 0.25, 0.5,
                  0.25, 0.25, 0.375, 0.125, 1,
                  0.25, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25,
                  0.25, 0.25, 0.25, 0.25, 0.5, 0.5
                };
int Tone_length = sizeof(Tone) / sizeof(Tone[0]);



static void NotifyCallback(BLERemoteCharacteristic* pBLERemoteCharacteristic, uint8_t* pData, size_t length, bool isNotify) {
  //  char buf[length + 1];
  //  for (size_t i = 0; i < length; i++) {
  //    buf[i] = pData[i];
  //  }
  //  buf[length] = 0;
  //Serial.printf("The contents received are:: %s\r\n", buf);
}


// Callback function for connection and disconnection between client and server
class MyClientCallback : public BLEClientCallbacks {
    void onConnect(BLEClient* pclient) {}
    void onDisconnect(BLEClient* pclient) {
      doSacn = true;
      connected = false;
      Serial.println("Lost connection to device");
      pBLEScan->setActiveScan(true);  //Turn on scanning
      pBLEScan->setInterval(100);
      pBLEScan->setWindow(99);
    }
};


bool ConnectToServer(void) {
  // Create client
  pClient = BLEDevice::createClient();
  //Serial.println("Create client");
  Serial.println("Creating a Client");

  // Add callback function for connection and disconnection between client and server
  pClient->setClientCallbacks(new MyClientCallback());  // Add callback function for connection and disconnection between client and server

  // Try to connect the device
  if (!pClient->connect(pServer)) {  // Try to connect the device
    Serial.println("Failed to connect to the device");
    return false;
  }
  //Serial.println("Connect device successfully");
  Serial.println("Bluetooth connection successful");
  // Try to get the service in the device
  pRemoteService = pClient->getService(serviceUUID);
  if (pRemoteService == nullptr) {
    pClient->disconnect();
    return false;
  }
  //Serial.println("Obtain service successfully");
  Serial.println("Obtaining Services successfully");
  //Send feature value binding
  pRemoteCharacteristic2 = pRemoteService->getCharacteristic(SEND_UUID);
  pRemoteCharacteristic3 = pRemoteService->getCharacteristic(Warning_UUID);

  // Try to get the characteristics in the service
  pRemoteCharacteristic = pRemoteService->getCharacteristic(charUUID);
  if (pRemoteCharacteristic == nullptr) {
    Serial.println("Failed to get attribute");
    pClient->disconnect();
    return false;
  }
  //Serial.println("Get features successfully");
  Serial.println("Obtaining the function successfully");
  // If the characteristic value can be read, read the data
  if (pRemoteCharacteristic->canRead()) {
    value = pRemoteCharacteristic->readValue();
    //    Serial.print("The characteristic value can be read and the current value is: ");
    //    Serial.println(value.c_str());
  }

  // If push is enabled for feature values, push receiving processing is added
  if (pRemoteCharacteristic->canNotify()) {
    pRemoteCharacteristic->registerForNotify(NotifyCallback);
  }
  connected = true;
  return true;
}


class MyAdvertisedDeviceCallbacks : public BLEAdvertisedDeviceCallbacks {
    void onResult(BLEAdvertisedDevice advertisedDevice) {
      //Serial.print("BLE Advertised Device found: ");
      //Serial.println(advertisedDevice.toString().c_str());

      // Callback function when a device is found
      if (advertisedDevice.haveServiceUUID() && advertisedDevice.getServiceUUID().equals(serviceUUID)) {
        //Serial.print("Find device！  address: ");
        advertisedDevice.getScan()->stop();                   // Stop current scan
        pServer = new BLEAdvertisedDevice(advertisedDevice);  // Temporary storage device
        doConnect = true;
        doSacn = false;
        //Serial.println("Find the device you want to connect");
        Serial.println("The device to connect has been found");
      }
    }
};


//Wheel movement
void Motor(int L1, int L2, int R1, int R2) {
  ledcWrite(13, L1);
  ledcWrite(12, L2);
  ledcWrite(15, R1);
  ledcWrite(14, R2);
}

//Interrupt function-----RISING
void risingCallback() {
  attachInterrupt(digitalPinToInterrupt(Ultrasonic_Pin), fallingCallback, FALLING);  //Enable descent interrupt
  prev_time = micros();                                                              //Start timing
}

//Interrupt function-----FALLING
void fallingCallback() {
  pwm_value = micros() - prev_time;  //Low level duration
  if ((pwm_value < 60000) && (pwm_value > 1)) {
    distance = pwm_value / 58;
  }
}

void callback1()  //Callback function
{
  RGB_LED6();  //Ultrasonic RGB lamp
}


//Ultrasonic ranging
void Get_Distance() {
  pinMode(Ultrasonic_Pin, OUTPUT);
  digitalWrite(Ultrasonic_Pin, LOW);
  delayMicroseconds(2);
  digitalWrite(Ultrasonic_Pin, HIGH);
  delayMicroseconds(20);
  digitalWrite(Ultrasonic_Pin, LOW);
  pinMode(Ultrasonic_Pin, INPUT);
  attachInterrupt(digitalPinToInterrupt(Ultrasonic_Pin), risingCallback, RISING);  //Enable rise interrupt
  //  int Time_Echo_us = pulseIn(Ultrasonic_Pin, HIGH);
  //  if ((Time_Echo_us < 10000) && (Time_Echo_us > 1)) {
  //    distance = Time_Echo_us / 58;
  //    Serial.print("Ultrasonic distance：");
  //    Serial.println(distance);
  //    itoa(distance, LU, 10);
  //    pRemoteCharacteristic2->writeValue(LU);
  //  }
}

//Baseboard RGB lamp ----- on
void RGB_LED() {
  FastLED.setBrightness(255);  //RGB lamp brightness range: 0-255
  myRGBcolor.r = random(0, 255);
  myRGBcolor.g = random(0, 255);
  myRGBcolor.b = random(0, 255);
  fill_solid(leds, 4, myRGBcolor);
  FastLED.show();
}

void RGB_LED_norandom() {
  FastLED.setBrightness(255);  //RGB lamp brightness range: 0-255

  for (int i = 0; i <= 3; i++) {
    leds[i] = CRGB::Red;
    FastLED.show();
    delay(500);

    leds[i] = CRGB::Black;
    FastLED.show();
    delay(500);  
  }
  myRGBcolor.r = 255;  //random(0, 255);
  myRGBcolor.g = 100;  //random(0, 255);
  myRGBcolor.b = 100;  //random(0, 255);
  fill_solid(leds, 4, myRGBcolor);
  FastLED.show();
  delay(2000);
}

//Backplane RGB lamp ----- off
void RGB_LED_Close() {
  FastLED.setBrightness(0);  //RGB lamp brightness range: 0-255
  myRGBcolor.r = 0;
  myRGBcolor.g = 0;
  myRGBcolor.b = 0;
  fill_solid(leds, 4, myRGBcolor);
  FastLED.show();
}

//Ultrasonic RGB lamp ----- on
void RGB_LED6() {
  FastLED.setBrightness(255);  //RGB lamp brightness range: 0-255
  myRGBcolor6.r = random(0, 255);
  myRGBcolor6.g = random(0, 255);
  myRGBcolor6.b = random(0, 255);
  fill_solid(RGBleds, 6, myRGBcolor6);
  FastLED.show();
}

void RGB_LED6_norandom() {
  FastLED.setBrightness(255);  //RGB lamp brightness range: 0-255
  myRGBcolor6.r = 255;         //random(0, 255);
  myRGBcolor6.g = 0;           //random(0, 255);
  myRGBcolor6.b = 255;         //random(0, 255);
  fill_solid(RGBleds, 6, myRGBcolor6);
  FastLED.show();
}

//Ultrasonic RGB lamp ----- off
void RGB_LED6_Close() {
  FastLED.setBrightness(0);  //RGB lamp brightness range: 0-255
  myRGBcolor6.r = 0;
  myRGBcolor6.g = 0;
  myRGBcolor6.b = 0;
  fill_solid(RGBleds, 6, myRGBcolor6);
  FastLED.show();
}

//infrared remote control
void IR_remote_control() {
  switch (state_N) {
    case 0xE718FF00:
      IR_Flag = 11;
      Serial.println("Forward");
      break;
    case 0xAD52FF00:
      IR_Flag = 22;
      Serial.println("Backward");
      break;
    case 0xF708FF00:
      IR_Flag = 33;
      Serial.println("Turn left");
      break;
    case 0xA55AFF00:
      IR_Flag = 44;
      Serial.println("Turn right");
      break;
    case 0xE31CFF00:
      IR_Flag = 55;
      Serial.println("Stop");
      break;
    case 0xBA45FF00:  //1
      IR_Flag = 1;
      break;
    case 0xB946FF00:  //2
      IR_Flag = 2;
      break;
    case 0xB847FF00:  //3
      IR_Flag = 3;
      break;
    case 0xBB44FF00:  //4
      IR_Flag = 4;
      break;
    case 0xE619FF00:  //0
      IR_Flag = 0;
      break;
    case 0xE916FF00:  //*
      IR_Flag = 6;
      break;
    case 0xF20DFF00:  //#
      IR_Flag = 7;
      break;
  }
}

//Line patrol procedure
void Tracking() {
  QTI_Max = digitalRead(QTI_L) * 2 + digitalRead(QTI_R);  //Black line return 1
  //Serial.println( QTI_Max);
  switch (QTI_Max) {
    case 3:
      Motor(160, 0, 160, 0);
      break;
    case 2:
      Motor(70, 0, 140, 0);
      break;
    case 1:
      Motor(140, 0, 70, 0);
      break;
    case 0:
      Motor(0, 120, 0, 120);
      break;
  }
}

//Line patrol - for testing

//Tracing procedure
void Find_light() {
  num_L = analogRead(Photodiode_L);
  num_R = analogRead(Photodiode_R);
  //    Serial.print("Left：");
  //    Serial.println(num_L);
  //    Serial.print("Right：");
  //    Serial.println(num_R);
  if (((num_L - num_R) > 250) && (num_R < 3700) && (num_L < 3700)) {  //Strong light on the right, right
    Motor(120, 0, 60, 0);
  } else if (((num_R - num_L) > 250) && (num_R < 3700) && (num_L < 3700)) {  //Strong light on the left, left
    Motor(60, 0, 120, 0);
  } else if ((((num_L - num_R) < 70) || ((num_R - num_L) < 70)) && (num_R < 3650) && (num_L < 3650)) {  //The light is straight ahead. Go straight
    Motor(120, 0, 120, 0);
  } else if (num_R > 3700 && num_L > 3700) {
    Motor(0, 0, 0, 0);
  }
}
void Find_light_ceshi() {
  num_L = analogRead(Photodiode_L);
  num_R = analogRead(Photodiode_R);
  Serial.print("Left：");
  Serial.println(num_L);
  Serial.print("Right：");
  Serial.println(num_R);
  if (((num_L - num_R) > 250) && (num_R < 3700) && (num_L < 3700)) {  //Strong light on the right, right
    //Motor(120, 0, 60, 0);
  } else if (((num_R - num_L) > 250) && (num_R < 3700) && (num_L < 3700)) {  //Strong light on the left, left
    //Motor(60, 0, 120, 0);
  } else if ((((num_L - num_R) < 70) || ((num_R - num_L) < 70)) && (num_R < 3650) && (num_L < 3650)) {  //The light is straight ahead. Go straight
    //Motor(120, 0, 120, 0);
  } else if (num_R > 3700 && num_L > 3700) {
    //Motor(0, 0, 0, 0);
  }
}


//Initialization program
void setup() {
  Serial.begin(115200);
  //Buzzer
  pinMode(33, OUTPUT);
  ledcSetup(2, 5000, 8);
  ledcAttachPin(33, 2);
  //Patrol
  pinMode(QTI_L, INPUT);
  pinMode(QTI_R, INPUT);
  //RGB lamp
  FastLED.addLeds<WS2812, 25, GRB>(leds, 4);     //RGB lamp pin 25, the number of lamps is 4
  FastLED.addLeds<WS2812, 26, GRB>(RGBleds, 6);  //RGB lamp pin 25, the number of lamps is 4
  FastLED.setBrightness(0);                      //RGB lamp brightness range: 0-255
  FastLED.show();
  //wheel
  pinMode(12, OUTPUT);  //Left wheel forward
  pinMode(13, OUTPUT);  //Left wheel backward
  pinMode(14, OUTPUT);  //Right wheel forward
  pinMode(15, OUTPUT);  //Right wheel backward
  //BT Switch
  pinMode(32, INPUT);  //BT Switch
  //TEST
  pinMode(4, OUTPUT);
  pinMode(23, OUTPUT);
  digitalWrite(4, LOW);
  digitalWrite(23, LOW);
  //OLED
  u8g2.begin();
  u8g2.enableUTF8Print();  // enable UTF8 support for the Arduino print() function
  u8g2.setFont(u8g2_font_ncenB14_tr);
  u8g2.setFontDirection(0);
  //Bind wheels
  for (int i = 12; i <= 15; i++) {  //Motor port is 12,13,14,15
    ledcSetup(i, 255, 8);           //leds Setting (channel, frequency, number of bits)
    ledcAttachPin(i, i);            //Motor port binding corresponding channel
  }
  //infrared remote control
  irrecv.enableIRIn();
  pinMode(RECV_PIN, INPUT);
  //BLE
  //Serial.println("Starting Arduino BLE Client application...");
  BLEDevice::init("");
  BLEDevice::setPower(ESP_PWR_LVL_P9);  //Set transmission frequency
  pBLEScan = BLEDevice::getScan();
  pBLEScan->setActiveScan(true);  //Turn on scanning
  pBLEScan->setInterval(100);
  pBLEScan->setWindow(80);
}


//while（1）
void loop() {
  //*************************************If Bluetooth switch -----on**************************************
  //*************************************If Bluetooth switch -----on**************************************
  //*************************************If Bluetooth switch -----on**************************************
  if (digitalRead(32) == LOW) {
    if (BLE_Close == 0) {
      ledcWrite(2, 0);  //Turn off the buzzer
      RGB_LED_Close();
      delay(30);
      RGB_LED6_Close();
      delay(20);
      Motor(0, 0, 0, 0);
      pBLEScan->setAdvertisedDeviceCallbacks(new MyAdvertisedDeviceCallbacks());
      pBLEScan->setActiveScan(true);  //Turn on scanning
      pBLEScan->setInterval(100);
      pBLEScan->setWindow(99);
      BLE_Close = 1;
    }

    // Scan if needed
    if (doSacn == true) {
      Serial.println("Start looking for Bluetooth devices...");
      //Serial.println("Start searching for devices");
      BLEDevice::getScan()->clearResults();
      BLEDevice::getScan()->start(1);  // Continuously search for devices
    }

    //If the connection is successful
    if (doConnect == true) {
      if (ConnectToServer() == true) {
        //Serial.println("We are now connecting to the server...");
        Serial.println("We are now connecting to the server...");
        Serial.println("3");
        delay(500);
        Serial.println("2");
        delay(500);
        Serial.println("1");
        delay(500);
        Serial.println("The connection is successful...");
        
        connected = true;
      } else {
        doSacn = true;
      }
      doConnect = false;
    }



    //If the device is connected
    if (connected == true) {
      value = pRemoteCharacteristic->readValue();
      //      Serial.print("Its characteristic value is:: ");
      //      Serial.println(value.c_str());

      //********************************Four buttons**************************************
      if (value == "A")  //Press key a to avoid obstacles, and then press close
      {
        Close_Flag = 1;
        if (shock_Flag == 0) {
          ledcWriteTone(2, Tone[3]);  //Buzzer
          delay(300);
          ledcWrite(2, 0);  //Turn off the buzzer
          delay(700);
          shock_Flag = 1;
        }
        while (Close_Flag == 1) {
          value = pRemoteCharacteristic->readValue();
          if (value == "I" || (digitalRead(32) == HIGH) || connected == false)  //Exit
          {
            Close_Flag = 0;
            pRemoteCharacteristic3->writeValue("G");
            Motor(0, 0, 0, 0);
            break;
          }
          ticker.attach_ms(40, callback1);  //lighting task
          Get_Distance();
          itoa(distance, LU, 10);
          pRemoteCharacteristic2->writeValue(LU);
          if (distance < 30) {
            pRemoteCharacteristic3->writeValue("S");
            Motor(130, 0, 0, 130);
          } else {
            pRemoteCharacteristic3->writeValue("G");
            Motor(130, 0, 130, 0);
          }
          if (value == "R")  //Right button ------------- buzzer rings for 300ms
          {
            ledcWriteTone(2, Tone[3]);  //Buzzer
            delay(150);
            ledcWrite(2, 0);
          }
        }
        value = pRemoteCharacteristic->readValue();
        if (value == "I" || (digitalRead(32) == HIGH) || connected == false)  //Exit
        {
          ticker.detach();  //End the lighting task
          shock_Flag = 0;
          Close_Flag = 0;
          RGB_LED6_Close();
          delay(20);
          Motor(0, 0, 0, 0);
        }
      }



      if (value == "B")  //Press button B ------ line patrol, and then press close
      {
        Close_Flag = 1;
        if (shock_Flag == 0) {
          ledcWriteTone(2, Tone[3]);  //Buzzer
          delay(300);
          ledcWrite(2, 0);  //Turn off the buzzer
          delay(700);
          shock_Flag = 1;
        }
        while (Close_Flag == 1) {
          value = pRemoteCharacteristic->readValue();
          if (value == "I" || (digitalRead(32) == HIGH) || connected == false)  //Exit
          {
            Close_Flag = 0;
            Motor(0, 0, 0, 0);
            break;
          }
          Tracking();  //Patrol

          if (value == "L")  //Left key ------------- turn on the RGB light randomly, and then press to turn off
          {
            L += 1;
            if (L % 2 == 1) {
              delay(180);
              RGB_LED6();  //Ultrasonic RGB lamp on
            } else {
              delay(180);
              RGB_LED6_Close();  //Ultrasonic RGB lamp off
            }
          }
          if (value == "R")  //Right button ------------- buzzer rings for 300ms
          {
            ledcWriteTone(2, Tone[3]);  //Buzzer
            delay(200);
            ledcWrite(2, 0);
          }
        }
        value = pRemoteCharacteristic->readValue();
        if (value == "I" || (digitalRead(32) == HIGH) || connected == false)  //Exit
        {
          shock_Flag = 0;
          Close_Flag = 0;
          RGB_LED6_Close();
          delay(10);
          Motor(0, 0, 0, 0);
        }
      }



      if (value == "C")  //Press key C ------ light seeking, and then press close
      {
        Close_Flag = 1;
        if (shock_Flag == 0) {
          ledcWriteTone(2, Tone[3]);  //Buzzer
          delay(300);
          ledcWrite(2, 0);  //Turn off the buzzer
          delay(700);
          shock_Flag = 1;
        }
        while (Close_Flag == 1) {
          value = pRemoteCharacteristic->readValue();
          if (value == "I" || (digitalRead(32) == HIGH) || connected == false)  //Exit
          {
            Close_Flag = 0;
            Motor(0, 0, 0, 0);
            break;
          }
          Find_light();      //Light seeking program
          if (value == "L")  //Left key ------------- turn on the RGB light randomly, and then press to turn off
          {
            L += 1;
            if (L % 2 == 1) {
              delay(180);
              RGB_LED6();  //Ultrasonic RGB lamp on
            } else {
              delay(180);
              RGB_LED6_Close();  //Ultrasonic RGB lamp off
            }
          }
          if (value == "R")  //Right button ------------- buzzer rings for 300ms
          {
            ledcWriteTone(2, Tone[3]);  //Buzzer
            delay(200);
            ledcWrite(2, 0);  //Turn off the buzzer
          }
        }
        value = pRemoteCharacteristic->readValue();
        if (value == "I" || (digitalRead(32) == HIGH) || connected == false)  //Exit
        {
          shock_Flag = 0;
          Close_Flag = 0;
          ledcWrite(2, 0);  //Turn off the buzzer
          RGB_LED6_Close();
          delay(10);
          Motor(0, 0, 0, 0);
        }
      }



      if (value == "D")  //Key D --- sing, flash, and then press to close
      {
        Close_Flag = 1;
        if (shock_Flag == 0) {
          ledcWriteTone(2, Tone[3]);  //Buzzer
          delay(300);
          ledcWrite(2, 0);  //Turn off the buzzer
          delay(700);
          shock_Flag = 1;
        }
        while (Close_Flag == 1) {
          value = pRemoteCharacteristic->readValue();
          if (value == "I" || (digitalRead(32) == HIGH) || connected == false)  //Exit
          {
            Close_Flag = 0;
            RGB_LED_Close();
            RGB_LED6_Close();
            Motor(0, 0, 0, 0);
            break;
          }
          for (int i = 0; i < Tone_length; i++) {  //Buzzer
            RGB_LED();                             //Backplane RGB lamp
            RGB_LED6();                            //Ultrasonic RGB lamp
            ledcWriteTone(2, Tone[i]);             //Buzzer
            delay(Time[i] * 100);
            delay(Time[i] * 100);
            value = pRemoteCharacteristic->readValue();
            if (value == "I")  //Exit
            {
              break;
            }
            delay(Time[i] * 100);
            delay(Time[i] * 100);
            value = pRemoteCharacteristic->readValue();
            if (value == "I")  //Exit
            {
              break;
            }
            delay(Time[i] * 100);
            value = pRemoteCharacteristic->readValue();
            if (value == "I")  //Exit
            {
              break;
            }
            delay(Time[i] * 500);
            ledcWrite(2, 0);  //Turn off the buzzer
            value = pRemoteCharacteristic->readValue();
            if (value == "I")  //Exit
            {
              break;
            }
          }
        }
        value = pRemoteCharacteristic->readValue();
        if (value == "I" || (digitalRead(32) == HIGH) || connected == false)  //Exit
        {
          shock_Flag = 0;
          Close_Flag = 0;
          ledcWrite(2, 0);  //Turn off the buzzer
          RGB_LED_Close();
          delay(10);
          RGB_LED6_Close();
          delay(10);
          Motor(0, 0, 0, 0);
        }
      }

      ticker.detach();  //End the lighting task

      //********************************Left and right buttons**************************************
      if (value == "L")  //Left key ------------- turn on the RGB light randomly, and then press to turn off
      {
        L += 1;
        if (L % 2 == 1) {
          delay(300);
          RGB_LED6();  //Ultrasonic RGB lamp oin
        } else {
          delay(300);
          RGB_LED6_Close();  //Ultrasonic RGB lamp off
        }
      }
      if (value == "R")  //Right button ------------- buzzer rings for 300ms
      {
        ledcWriteTone(2, Tone[3]);  //Buzzer
        delay(200);
        ledcWrite(2, 0);
      }

      //********************************rocker******************************************
      if (value == "Y")  //forward
      {
        //delay(5);
        Motor(160, 0, 160, 0);
      }

      if (value == "X")  //towards the right
      {
        Motor(80, 0, 0, 80);
      }

      if (value == "y")  //backward
      {
        //delay(5);
        Motor(0, 160, 0, 160);
      }

      if (value == "x")  //towards the left
      {
        Motor(0, 80, 80, 0);
      }

      if (value == "XY")  //Right up
      {
        //delay(5);
        Motor(170, 0, 120, 0);
      }

      if (value == "Xy")  //Lower right
      {
        //delay(5);
        Motor(0, 170, 0, 120);
      }

      if (value == "xY")  //Upper left
      {
        //delay(5);
        Motor(120, 0, 170, 0);
      }

      if (value == "xy")  //Lower left
      {
        //delay(5);
        Motor(0, 120, 0, 170);
      }

      if (value == "N")  //stop it
      {
        Motor(0, 0, 0, 0);
      }
      delay(5);
    }

  } else {
    //*********************************normal mode***************************************
  
    //If the Bluetooth switch ----- is off
    if (BLE_Close == 1) {
      BLE_Close = 0;
      RGB_LED_Close();
      delay(5);
      RGB_LED6_Close();
      delay(5);
      Motor(0, 0, 0, 0);
      pBLEScan->setActiveScan(false);  //Stop the scan
      doConnect = false;
      connected = false;
      doSacn = true;
      pClient->disconnect();
    }
    //infrared remote control
    Close_Flag = 1;
    while (Close_Flag == 1 && digitalRead(32) == HIGH) {
      if (irrecv.decode()) {
        irrecv.printIRResultShort(&Serial); // Print complete received data in one line
        if (irrecv.decodedIRData.decodedRawData, HEX == 0xFFFFFFFFF) {
          state_N = state_L;
        } else {
          state_N = irrecv.decodedIRData.decodedRawData, HEX;
          state_L = irrecv.decodedIRData.decodedRawData, HEX;
        }

        IR_remote_control();
        switch (IR_Flag) {
          case 11:  //Forward
            Motor(240, 0, 240, 0);
            break;
          case 22:  //retreat
            Motor(0, 220, 0, 220);
            break;
          case 33:  //turn left
            Motor(0, 180, 180, 0);
            break;
          case 44:  //turn right
            Motor(180, 0, 0, 180);
            break;
          case 55:  //stop
            Motor(0, 0, 0, 0);
            ledcWriteTone(2, Tone[3]);  //Buzzer
            delay(150);
            ledcWrite(2, 0);
            break;



          case 1:  //*********************1********************
            Serial.println("Turn on ultrasonic mode");
            Close_Flag = 1;
            if (shock_Flag == 0) {
              ledcWriteTone(2, Tone[3]);  //Buzzer
              delay(300);
              ledcWrite(2, 0);  
              delay(700);
              shock_Flag = 1;
            }
            while (Close_Flag == 1) {
              RGB_LED6();  //Ultrasonic RGB lamp
              delay(40);
              Get_Distance();
              Serial.print("Ultrasonic wave distance：");
              Serial.print(distance);
              Serial.print("cm");
              Serial.println();
              if (distance < 30) {
                Motor(220, 0, 0, 220);
              } else {
                Motor(220, 0, 220, 0);
              }
              delay(20);
              if (irrecv.decode()) {
                if (irrecv.decodedIRData.decodedRawData, HEX == 0xFFFFFFFFF) {
                  state_N = state_L;
                } else {
                  state_N = irrecv.decodedIRData.decodedRawData, HEX;
                  state_L = irrecv.decodedIRData.decodedRawData, HEX;
                }
                IR_remote_control();
                switch (IR_Flag) {
                  case 7:  //Buzzer
                    Serial.println("Trun on Buzzer");
                    ledcWriteTone(2, Tone[3]);  //Buzzer
                    delay(150);
                    ledcWrite(2, 0);
                    break;
                }
                irrecv.resume();
              }
              if (IR_Flag == 6 || IR_Flag == 7)  //Restore to 1 after one run
              {
                IR_Flag = 1;
              }
              if (IR_Flag == 55)  //Exit
              {
                Close_Flag = 0;
                break;
              }
            }
            if (IR_Flag == 55)  //Exit
            {
              IR_Flag = 88;
              shock_Flag = 0;
              Close_Flag = 0;
              ledcWrite(2, 0);
              RGB_LED6_Close();  //Ultrasonic RGB lamp off
              delay(15);
              RGB_LED_Close();  //Bottom RGB light off
              delay(15);
              Motor(0, 0, 0, 0);  //Close the steering gear
              Serial.println("Exit ultrasonic mode");
            }
            break;

          case 2:  //*********************2********************************
            Serial.println("Turn on the patrol mode");
            Close_Flag = 1;
            if (shock_Flag == 0) {
              ledcWriteTone(2, Tone[3]);  //Buzzer
              delay(300);
              ledcWrite(2, 0);  //trun off Buzzer
              delay(700);
              shock_Flag = 1;
            }
            while (Close_Flag == 1) {
              Tracking();  //line patrol
              delay(2);
              if (irrecv.decode()) {
                if (irrecv.decodedIRData.decodedRawData, HEX == 0xFFFFFFFFF) {
                  state_N = state_L;
                } else {
                  state_N = irrecv.decodedIRData.decodedRawData, HEX;
                  state_L = irrecv.decodedIRData.decodedRawData, HEX;
                }
                IR_remote_control();
                switch (IR_Flag) {
                  case 6:  //Ultrasonic RGB lamp
                    L += 1;
                    if (L % 2 == 1) {
                      RGB_LED6_norandom();  //turn on Ultrasonic RGB lamp
                      delay(30);
                      Serial.println("Turn on ultrasonic RGB");
                    } else {
                      RGB_LED6_Close();  //Ultrasonic RGB lamp off
                      delay(30);
                      Serial.println("Turn off ultrasonic RGB");
                    }
                    break;
                  case 7:  //Buzzer
                    Serial.println("trun on Buzzer");
                    ledcWriteTone(2, Tone[3]);  //Buzzer
                    delay(150);
                    ledcWrite(2, 0);
                    break;
                }
                irrecv.resume();
              }
              if (IR_Flag == 6 || IR_Flag == 7)  //Run this command once and restore to 2
              {
                IR_Flag = 2;
              }
              if (IR_Flag == 55)  //Exit
              {
                Close_Flag = 0;
                break;
              }
            }
            if (IR_Flag == 55)  //Exit
            {
              IR_Flag = 88;
              shock_Flag = 0;
              Close_Flag = 0;
              ledcWrite(2, 0);
              RGB_LED6_Close();  //Ultrasonic RGB lamp off
              delay(15);
              RGB_LED_Close();  //Bottom RGB light off
              delay(15);
              Motor(0, 0, 0, 0);  //Close the steering gear
              Serial.println("Exit Line patrol mode");
            }
            break;

          case 3:  //*********************3********************************
            Serial.println("Enable light seeking mode");
            Close_Flag = 1;
            if (shock_Flag == 0) {
              ledcWriteTone(2, Tone[3]);  //Buzzer
              delay(300);
              ledcWrite(2, 0);  //Trun off Buzzer
              delay(700);
              shock_Flag = 1;
              //ticker.attach(2, callback1);   //callback1 is called every second
            }
            while (Close_Flag == 1) {
              Find_light();
              if (irrecv.decode()) {
                if (irrecv.decodedIRData.decodedRawData, HEX == 0xFFFFFFFFF) {
                  state_N = state_L;
                } else {
                  state_N = irrecv.decodedIRData.decodedRawData, HEX;
                  state_L = irrecv.decodedIRData.decodedRawData, HEX;
                }
                IR_remote_control();
                switch (IR_Flag) {
                  case 6:  //Ultrasonic RGB lamp
                    L += 1;
                    if (L % 2 == 1) {
                      RGB_LED6_norandom();  //turn on Ultrasonic RGB lamp
                      delay(30);
                      Serial.println("Turn on ultrasonic RGB");
                    } else {
                      RGB_LED6_Close();  //Ultrasonic RGB lamp off
                      delay(30);
                      Serial.println("Turn off ultrasonic RGB");
                    }
                    break;
                  case 7:  //Buzzer
                    Serial.println("Trun on Buzzer");
                    ledcWriteTone(2, Tone[3]);  //Buzzer
                    delay(150);
                    ledcWrite(2, 0);
                    break;
                }
                irrecv.resume();
              }
              if (IR_Flag == 6 || IR_Flag == 7)  //Run this command once and restore to 2
              {
                IR_Flag = 3;
              }
              if (IR_Flag == 55)  //Exit
              {
                Close_Flag = 0;
                break;
              }
            }
            if (IR_Flag == 55)  //Exit
            {
              IR_Flag = 88;
              shock_Flag = 0;
              Close_Flag = 0;
              ledcWrite(2, 0);
              RGB_LED6_Close();  //Ultrasonic RGB lamp off
              delay(15);
              RGB_LED_Close();  //Bottom RGB light off
              delay(15);
              Motor(0, 0, 0, 0);  //Close the steering gear
              Serial.println("Exit Indicates the optical search mode");
            }
            break;

          case 4:  //*********************4********************************
            Serial.println("Enable RGB and sing modes");
            Close_Flag = 1;
            if (shock_Flag == 0) {
              ledcWriteTone(2, Tone[3]);  //Buzzer
              delay(300);
              ledcWrite(2, 0); 
              delay(700);
              shock_Flag = 1;
            }
            while (Close_Flag == 1) {
              for (int i = 0; i < Tone_length; i++) {          //Buzzer
                RGB_LED();                                     //Backplane RGB lamp
                RGB_LED6();                                    //Ultrasonic RGB lamp
                ledcWriteTone(2, Tone[i]);                     //Buzzer
                for (int j = 0; j < (Time[i] / 0.020); j++) {  //Buzzer
                  delay(20);
                  if (irrecv.decode()) {
                    if (irrecv.decodedIRData.decodedRawData, HEX == 0xFFFFFFFFF) {
                      state_N = state_L;
                    } else {
                      state_N = irrecv.decodedIRData.decodedRawData, HEX;
                      state_L = irrecv.decodedIRData.decodedRawData, HEX;
                    }
                    IR_remote_control();
                    if (IR_Flag == 55)  //Exit
                    {
                      Close_Flag = 0;
                      break;
                    }
                    irrecv.resume();
                  }
                }
                if (irrecv.decode()) {
                  if (irrecv.decodedIRData.decodedRawData, HEX == 0xFFFFFFFFF) {
                    state_N = state_L;
                  } else {
                    state_N = irrecv.decodedIRData.decodedRawData, HEX;
                    state_L = irrecv.decodedIRData.decodedRawData, HEX;
                  }
                  IR_remote_control();
                  if (IR_Flag == 55)  //Exit
                  {
                    Close_Flag = 0;
                    ledcWrite(2, 0);
                    RGB_LED6_Close();  //Ultrasonic RGB lamp off
                    delay(15);
                    RGB_LED_Close();  //Bottom RGB light off
                    delay(15);
                    break;
                  }
                  irrecv.resume();
                }
              }
              ledcWrite(2, 0);  //trun off Buzzer
              if (irrecv.decode()) {
                if (irrecv.decodedIRData.decodedRawData, HEX == 0xFFFFFFFFF) {
                  state_N = state_L;
                } else {
                  state_N = irrecv.decodedIRData.decodedRawData, HEX;
                  state_L = irrecv.decodedIRData.decodedRawData, HEX;
                }
                IR_remote_control();
                if (IR_Flag == 55)  //Exit
                {
                  Close_Flag = 0;
                  ledcWrite(2, 0);
                  RGB_LED6_Close();  //Ultrasonic RGB lamp off
                  delay(15);
                  RGB_LED_Close();  
                  delay(15);
                  break;
                }
                irrecv.resume();
              }
            }
            if (IR_Flag == 55)  //Exit
            {
              IR_Flag = 88;
              shock_Flag = 0;
              Close_Flag = 0;
              ledcWrite(2, 0);
              RGB_LED6_Close();  //Ultrasonic RGB lamp off
              delay(15);
              RGB_LED_Close();  
              delay(15);
              Motor(0, 0, 0, 0); 
              Serial.println("Exit RGB and sing modes");
            }
            break;

          case 0:  //*********************0********************************
            Serial.println("Enable the 4-in-1 mode");
            Close_Flag = 1;
            if (shock_Flag == 0) {
              ledcWriteTone(2, Tone[3]);  //Buzzer
              delay(300);
              ledcWrite(2, 0);  //关闭Buzzer
              delay(700);
              shock_Flag = 1;
            }
            while (Close_Flag == 1) {
              for (int i = 0; i < Tone_length; i++) {          //Buzzer
                RGB_LED();                                     //Backplane RGB lamp
                RGB_LED6();                                    //Ultrasonic RGB lamp
                ledcWriteTone(2, Tone[i]);                     //Buzzer
                for (int j = 0; j < (Time[i] / 0.020); j++) {  //Buzzer
                  Get_Distance();
                  Serial.print("Ultrasonic wave distance：");
                  Serial.println(distance);
                  if (distance < 30) {
                    Motor(0, 0, 0, 0);
                  } else {
                    Tracking();  
                  }
                  delay(20);
                  if (irrecv.decode()) {
                    if (irrecv.decodedIRData.decodedRawData, HEX == 0xFFFFFFFFF) {
                      state_N = state_L;
                    } else {
                      state_N = irrecv.decodedIRData.decodedRawData, HEX;
                      state_L = irrecv.decodedIRData.decodedRawData, HEX;
                    }
                    IR_remote_control();
                    if (IR_Flag == 55)  //Exit
                    {
                      Close_Flag = 0;
                      break;
                    }
                    irrecv.resume();
                  }
                }
                if (irrecv.decode()) {
                  if (irrecv.decodedIRData.decodedRawData, HEX == 0xFFFFFFFFF) {
                    state_N = state_L;
                  } else {
                    state_N = irrecv.decodedIRData.decodedRawData, HEX;
                    state_L = irrecv.decodedIRData.decodedRawData, HEX;
                  }
                  IR_remote_control();
                  if (IR_Flag == 55)  //Exit
                  {
                    Close_Flag = 0;
                    ledcWrite(2, 0);
                    RGB_LED6_Close();  //Ultrasonic RGB lamp off
                    delay(10);
                    RGB_LED_Close();  
                    delay(10);
                    break;
                  }
                  irrecv.resume();
                }
              }
              ledcWrite(2, 0); 
              if (irrecv.decode()) {
                if (irrecv.decodedIRData.decodedRawData, HEX == 0xFFFFFFFFF) {
                  state_N = state_L;
                } else {
                  state_N = irrecv.decodedIRData.decodedRawData, HEX;
                  state_L = irrecv.decodedIRData.decodedRawData, HEX;
                }
                IR_remote_control();
                if (IR_Flag == 55)  //Exit
                {
                  Close_Flag = 0;
                  ledcWrite(2, 0);
                  RGB_LED6_Close();  //Ultrasonic RGB lamp off
                  delay(15);
                  RGB_LED_Close();  
                  delay(15);
                  break;
                }
                irrecv.resume();
              }
            }
            if (IR_Flag == 55)  //Exit
            {
              IR_Flag = 88;
              shock_Flag = 0;
              Close_Flag = 0;
              ledcWrite(2, 0);
              RGB_LED6_Close();  //Ultrasonic RGB lamp off
              delay(15);
              RGB_LED_Close(); 
              delay(15);
              Motor(0, 0, 0, 0);  
              Serial.println("Exit 4 in 1 mode");
            }
            break;

          case 6:  //**********************6********************************
            Serial.println("Open the light");
            L += 1;
            if (L % 2 == 1) {
              RGB_LED6();  //Ultrasonic RGB lamp
              delay(50);
              Serial.println("Turn on ultrasonic RGB");
            } else {
              RGB_LED6_Close();  //Ultrasonic RGB lamp off
              delay(50);
              Serial.println("Turn off ultrasonic RGB");
            }
            break;

          case 7:  //**********************7********************************
            Serial.println("turn on Buzzer");
            ledcWriteTone(2, Tone[3]);  //Buzzer
            break;
          default:
            Motor(0, 0, 0, 0);
            break;
        }

        irrecv.resume();
      } else {
        Motor(0, 0, 0, 0);
        ledcWrite(2, 0);
      }
      delay(150);

      
    }
  }
}
