#include <BLEDevice.h>
#include <BLEServer.h>
#include <BLEUtils.h>
#include <BLE2902.h>
//#include <SSD1306.h>
#include <U8g2lib.h>
#ifdef U8X8_HAVE_HW_I2C
#include <Wire.h>
#endif
U8G2_SSD1306_128X32_UNIVISION_F_SW_I2C u8g2(U8G2_R0, /* clock=*/5, /* data=*/4, /* reset=*/U8X8_PIN_NONE);  // Adafruit Feather ESP8266/32u4 Boards + FeatherWing OLED
#define SDA 4
#define SCL 5
#include <Ticker.h>          //Call the ticker. H Library
Ticker ticker1;              //Declare the ticker object --- when Bluetooth is disconnected or not connected, 19 lights flash
Ticker ticker_Y;             //Y
Ticker ticker_meum;          //meum
Ticker ticker_warning;       //warning
Ticker ticker_y;             //y
Ticker ticker_X;             //X
Ticker ticker_x;             //x
Ticker ticker_A;             //A
Ticker ticker_B;             //B
Ticker ticker_C;             //C
Ticker ticker_D;             //D
Ticker ticker_buzzer;        //buzzer
Ticker ticker_buzzer_close;  //buzzer_close
Ticker ticker_disconecting;  //disconecting
Ticker ticker_conecting;     //conecting
Ticker OPEN;                 //Vibration on
Ticker CLOSE;                //Vibration off
int A;                       //Save four key ADC values
int X = 0;
int Y = 0;
int L = 0;
int R = 0;
int I = 0;
//SSD1306 displayOLED(0x3c, SDA, SCL);//OLED
BLEAdvertising* pAdvertising = NULL;
BLEServer* pServer = NULL;
BLECharacteristic* pCharacteristic = NULL;
BLECharacteristic* pCharacteristic2 = NULL;
BLECharacteristic* pCharacteristic3 = NULL;
BLEService* pService = NULL;
std::string Distance;  //Ultrasonic distance
std::string Value;     //characteristic value
std::string Warning;   //warning
bool deviceConnected = false;
bool oldDeviceConnected = false;
char direction = 'Q';  //Which key is used for the save handle
int Flag = 0;          //Mark of returning to the middle position after using the push rod
int Bb[10] = { 0 };    //Array for comparing four keys
int i = 0;
int flag = 0;         //Get the flags of the four keys
int Close_Flag = 0;   //Close program flag
char serialData;      //Save serial port data
int First = 0;        //Just started flag
int shock_Flag = 0;   //Vibration sign
int buzzer_Flag = 0;  //Buzzer sign
int go_Flag = 0;      //Forward sign
int turn_Flag = 0;    //Turn sign
int button_Flag = 0;  //Four keys press the flag
//Because there are pictures displayed in the front, rear, left and right of the rocker, which will affect the use of the buzzer, the flag bit is used. When the rocker is always in one direction, the operation of displaying pictures is only performed once
int Y_Flag = 0;
int y_Flag = 0;
int X_Flag = 0;
int x_Flag = 0;
//Generate UUIDs from the following URL
// https://www.uuidgenerator.net/
#define SERVICE_UUID "6479571c-2e6d-4b34-abe9-c35116712345"  //Host service UUID
//#define SERVICE_UUID         "6479571c-2e6d-4b34-abe9-c351167d5be6"
#define CHARACTERISTIC_UUID "826f072d-f87c-4ae6-a416-6ffdcaa02d73"
#define RECV_UUID "a655223b-5f59-4794-ba1f-3e8a4f51da69"
#define WARN_UUID "71d5a0ad-0f4c-49c4-856c-612d837c5f86"
#define G4 392
#define A4 440
#define B4 494
#define C5 523
#define D5 587
#define E5 659
#define F5 698
#define G5 784

//Typeface
const unsigned char disconecting[] U8X8_PROGMEM = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x07, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x7f, 0x00, 0x00, 0x00, 0x80, 0x3f, 0xff, 0x01, 0x00, 0x00, 0xc0, 0x3f, 0xfc, 0x03, 0x00, 0x00, 0xe0, 0x3f, 0xf0, 0x07, 0x00, 0x30, 0xe0, 0x3f, 0xe0, 0x07, 0x08, 0x78, 0xf0, 0x39, 0x82, 0x0f, 0x1c, 0xf0, 0xf0, 0x30, 0x0e, 0x0f, 0x0f, 0xc0, 0xf9, 0x01, 0x86, 0x8f, 0x03, 0x80, 0xf8, 0x03, 0xc0, 0x0f, 0x01, 0x00, 0xf8, 0x0f, 0xf0, 0x0f, 0x00, 0xfc, 0xf9, 0x1f, 0xf8, 0x8f, 0x3f, 0xfc, 0xf9, 0x0f, 0xf0, 0x0f, 0x3f, 0x00, 0xf8, 0x07, 0xe0, 0x0f, 0x00, 0xc0, 0xf9, 0x01, 0x86, 0x8f, 0x03, 0xe0, 0xf1, 0x20, 0x0e, 0x8f, 0x07, 0x78, 0xf0, 0x39, 0x82, 0x0f, 0x1e, 0x38, 0xf0, 0x3f, 0xe0, 0x07, 0x1c, 0x00, 0xe0, 0x3f, 0xf0, 0x07, 0x00, 0x00, 0xe0, 0x3f, 0xfc, 0x03, 0x00, 0x00, 0x80, 0x3f, 0xfe, 0x01, 0x00, 0x00, 0x00, 0xbf, 0x7f, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char conecting[] U8X8_PROGMEM = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x07, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x7f, 0x00, 0x00, 0x00, 0x80, 0x3f, 0xff, 0x01, 0x00, 0x00, 0xc0, 0x3f, 0xfc, 0x03, 0x00, 0x00, 0xe0, 0x3f, 0xf0, 0x07, 0x00, 0x00, 0xe0, 0x3f, 0xe0, 0x07, 0x00, 0x00, 0xf0, 0x39, 0x82, 0x0f, 0x00, 0x00, 0xf0, 0x30, 0x0e, 0x0f, 0x00, 0x00, 0xf8, 0x01, 0x86, 0x0f, 0x00, 0x00, 0xf8, 0x03, 0xc0, 0x0f, 0x00, 0x00, 0xf8, 0x0f, 0xf0, 0x0f, 0x00, 0x00, 0xf8, 0x1f, 0xf8, 0x0f, 0x00, 0x00, 0xf8, 0x0f, 0xf0, 0x0f, 0x00, 0x00, 0xf8, 0x07, 0xe0, 0x0f, 0x00, 0x00, 0xf8, 0x01, 0x86, 0x0f, 0x00, 0x00, 0xf0, 0x20, 0x0e, 0x0f, 0x00, 0x00, 0xf0, 0x39, 0x82, 0x0f, 0x00, 0x00, 0xf0, 0x3f, 0xe0, 0x07, 0x00, 0x00, 0xe0, 0x3f, 0xf0, 0x07, 0x00, 0x00, 0xe0, 0x3f, 0xfc, 0x03, 0x00, 0x00, 0x80, 0x3f, 0xfe, 0x01, 0x00, 0x00, 0x00, 0xbf, 0x7f, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char go[] U8X8_PROGMEM = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x01, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0xe0, 0x07, 0x00, 0x00, 0xf0, 0x0f, 0x00, 0x00, 0x78, 0x1e, 0x00, 0x00, 0x1c, 0x38, 0x00, 0x00, 0x0c, 0x30, 0x00, 0x00, 0x82, 0x41, 0x00, 0x00, 0x81, 0x81, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0xe0, 0x07, 0x00, 0x00, 0x70, 0x0e, 0x00, 0x00, 0x38, 0x1c, 0x00, 0x00, 0x1c, 0x38, 0x00, 0x00, 0x06, 0x60, 0x00, 0x00, 0x82, 0x41, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0xe0, 0x07, 0x00, 0x00, 0xe0, 0x07, 0x00, 0x00, 0x70, 0x0e, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x0c, 0x30, 0x00, 0x00, 0x02, 0x40, 0x00, 0x00, 0x01, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char turn[] U8X8_PROGMEM = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x00, 0x00, 0x06, 0x60, 0x00, 0x00, 0x0c, 0x30, 0x00, 0x00, 0x38, 0x1c, 0x00, 0x00, 0x70, 0x0e, 0x00, 0x00, 0xf0, 0x0f, 0x00, 0x00, 0xe0, 0x07, 0x00, 0x00, 0xc1, 0x83, 0x00, 0x00, 0x83, 0xc1, 0x00, 0x00, 0x0e, 0x70, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x78, 0x1e, 0x00, 0x00, 0xf0, 0x0f, 0x00, 0x00, 0xe0, 0x07, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0x81, 0x81, 0x00, 0x00, 0x86, 0x60, 0x00, 0x00, 0x0c, 0x30, 0x00, 0x00, 0x38, 0x1c, 0x00, 0x00, 0x70, 0x0e, 0x00, 0x00, 0xf0, 0x0f, 0x00, 0x00, 0xe0, 0x07, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0x80, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char AA[] U8X8_PROGMEM = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xfe, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x1f, 0x00, 0x83, 0x01, 0x00, 0x64, 0x01, 0x00, 0x00, 0x02, 0x00, 0xc0, 0x1f, 0x80, 0x7d, 0x03, 0x00, 0x64, 0x05, 0x00, 0x00, 0x02, 0x00, 0xe0, 0x3d, 0x80, 0xc6, 0x06, 0x00, 0x64, 0x7d, 0x73, 0xe6, 0x32, 0x00, 0xf0, 0x79, 0x40, 0x93, 0x05, 0x00, 0x64, 0xb5, 0x54, 0xad, 0x5a, 0x00, 0xf0, 0x71, 0x40, 0x31, 0x0d, 0x00, 0x64, 0x15, 0x37, 0xa9, 0x0a, 0x00, 0xb0, 0x65, 0xc0, 0x39, 0x0a, 0x00, 0x24, 0x95, 0x65, 0xa9, 0x4a, 0x00, 0x30, 0x65, 0xa0, 0x28, 0x0a, 0x00, 0x2c, 0x95, 0x56, 0xad, 0x5a, 0x00, 0x70, 0x74, 0xa0, 0x68, 0x0a, 0x00, 0x38, 0x1d, 0x77, 0xa6, 0x32, 0x00, 0x70, 0x70, 0xa0, 0x7c, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x78, 0xa0, 0x44, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x78, 0xe0, 0x44, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x70, 0x40, 0xc5, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x30, 0x13, 0x00, 0x70, 0x74, 0x40, 0x01, 0x05, 0x00, 0x00, 0x00, 0x00, 0x58, 0x13, 0x00, 0x30, 0x65, 0xc0, 0x82, 0x04, 0x00, 0x00, 0x00, 0x00, 0x08, 0x53, 0x00, 0xf0, 0x65, 0x90, 0x7d, 0x32, 0x00, 0x00, 0x00, 0x00, 0x08, 0x1b, 0x00, 0xf0, 0x71, 0x10, 0x11, 0x13, 0x00, 0x00, 0x00, 0x00, 0x08, 0x1d, 0x00, 0xf0, 0x79, 0x20, 0xce, 0x19, 0x00, 0x00, 0x00, 0x00, 0x48, 0x1d, 0x00, 0xe0, 0x3d, 0x60, 0x7c, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x70, 0x55, 0x00, 0xc0, 0x1d, 0xc0, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x0f, 0x80, 0x03, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0xfe, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char BB[] U8X8_PROGMEM = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0xfc, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x01, 0x00, 0x07, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xff, 0x03, 0x80, 0xf9, 0x19, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0xef, 0x07, 0xc0, 0x0c, 0x37, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0xcf, 0x07, 0x40, 0x02, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x0f, 0x0f, 0x60, 0xf9, 0x59, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x6d, 0x0e, 0xa0, 0x19, 0xd3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x68, 0x0e, 0xb0, 0x18, 0xd3, 0x00, 0x40, 0x10, 0x00, 0x80, 0x0f, 0x90, 0x00, 0x00, 0x00, 0xe0, 0x21, 0x0f, 0xb0, 0xf8, 0xd1, 0x00, 0x40, 0x10, 0x00, 0x80, 0x01, 0x90, 0x00, 0x00, 0x00, 0xe0, 0x83, 0x1f, 0xb0, 0xf8, 0xd1, 0x00, 0x40, 0x90, 0xc7, 0x81, 0xc1, 0x93, 0x9c, 0x6c, 0x00, 0xe0, 0x87, 0x1f, 0xb0, 0x18, 0xd3, 0x00, 0x40, 0x90, 0x24, 0x83, 0x4f, 0x92, 0xb6, 0x2d, 0x00, 0xe0, 0x87, 0x1f, 0xa0, 0x18, 0xd3, 0x00, 0x40, 0x90, 0xe4, 0xbb, 0x6f, 0x96, 0x26, 0x2d, 0x00, 0xe0, 0x03, 0x1f, 0x60, 0xf9, 0xdb, 0x00, 0x40, 0x90, 0x24, 0xb9, 0x61, 0x96, 0x26, 0x3b, 0x00, 0xe0, 0x61, 0x0f, 0x60, 0xfb, 0x6d, 0x00, 0xc0, 0x93, 0x64, 0x83, 0x41, 0x92, 0x36, 0x1b, 0x00, 0xe0, 0x68, 0x0e, 0xc0, 0x06, 0x26, 0x00, 0xc0, 0x97, 0xc4, 0x81, 0x80, 0x91, 0x1c, 0x12, 0x00, 0xe0, 0x2d, 0x0e, 0x8c, 0xfd, 0x33, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x0f, 0x0f, 0x18, 0xf3, 0x1c, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x8f, 0x07, 0x10, 0x1e, 0x8f, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0xcf, 0x07, 0x70, 0xf8, 0xc3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xef, 0x03, 0xc0, 0x00, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x01, 0x80, 0x03, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x00, 0xfe, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char CC[] U8X8_PROGMEM = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfc, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x01, 0x00, 0x07, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xef, 0x03, 0x80, 0xf9, 0x19, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xcf, 0x07, 0xc0, 0x0c, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x8f, 0x07, 0x40, 0x02, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x0f, 0x0f, 0x60, 0xf1, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x2c, 0x0e, 0xa0, 0x08, 0xd3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x68, 0x0e, 0xa0, 0x0c, 0xd0, 0x00, 0x83, 0x00, 0x01, 0xc0, 0x01, 0x00, 0x42, 0x00, 0x00, 0xe0, 0x21, 0x0f, 0xa0, 0x0c, 0x90, 0x00, 0x02, 0x00, 0x41, 0x60, 0x02, 0x00, 0x02, 0x00, 0x00, 0xe0, 0x03, 0x0f, 0xb0, 0x04, 0x90, 0x00, 0x82, 0x3c, 0xe7, 0x20, 0xe0, 0x30, 0x52, 0x1e, 0x0f, 0xe0, 0x87, 0x0f, 0xa0, 0x0c, 0x90, 0x00, 0x82, 0x24, 0x49, 0xc0, 0x21, 0x49, 0x4a, 0xb6, 0x0d, 0xe0, 0x87, 0x0f, 0xa0, 0x08, 0xd3, 0x00, 0x82, 0x22, 0x49, 0x06, 0xf6, 0x7d, 0x46, 0xb2, 0x08, 0xe0, 0x03, 0x0f, 0x20, 0x99, 0x59, 0x00, 0x82, 0x22, 0x49, 0x26, 0x14, 0x0c, 0x4a, 0xb2, 0x08, 0xe0, 0x21, 0x0e, 0x60, 0xe3, 0x68, 0x00, 0x82, 0x34, 0x49, 0x60, 0x26, 0x49, 0x5a, 0x32, 0x0d, 0xe0, 0x68, 0x0e, 0xc0, 0x06, 0x26, 0x00, 0x9e, 0x28, 0x88, 0xc0, 0xc1, 0x30, 0x12, 0x22, 0x0a, 0xe0, 0x2d, 0x0e, 0x8c, 0xb9, 0x13, 0x02, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x0d, 0xc0, 0x0f, 0x0f, 0x08, 0x03, 0x18, 0x01, 0x00, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0xc0, 0x8f, 0x07, 0x10, 0x0e, 0x87, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xcf, 0x07, 0x20, 0xf8, 0xc1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xef, 0x03, 0xc0, 0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x00, 0x80, 0x03, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char DD[] U8X8_PROGMEM = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfc, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x01, 0x00, 0x07, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xef, 0x03, 0x80, 0xf9, 0x19, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xef, 0x07, 0xc0, 0x0c, 0x37, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0xcf, 0x07, 0x40, 0x02, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x0f, 0x0f, 0x60, 0xf9, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x6d, 0x0e, 0xa0, 0x19, 0xd3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x68, 0x0e, 0xb0, 0x18, 0xd6, 0x00, 0x00, 0x47, 0x00, 0x00, 0x80, 0x2f, 0x00, 0x00, 0x00, 0xe0, 0x21, 0x0f, 0xb0, 0x18, 0x96, 0x00, 0x80, 0x4c, 0x00, 0x00, 0x80, 0x0f, 0x00, 0x00, 0x00, 0xe0, 0x83, 0x0f, 0xb0, 0x18, 0x96, 0x00, 0xc0, 0xc8, 0xe1, 0x26, 0x01, 0x22, 0x6f, 0x1c, 0x00, 0xe0, 0x87, 0x0f, 0xb0, 0x18, 0xd6, 0x00, 0x80, 0xc7, 0x92, 0xb4, 0x01, 0x22, 0x5b, 0x12, 0x00, 0xe0, 0x87, 0x0f, 0xa0, 0x18, 0xd2, 0x00, 0x00, 0x4e, 0x12, 0xb5, 0x00, 0x22, 0x49, 0x3e, 0x00, 0xe0, 0x03, 0x0f, 0x20, 0xf9, 0x5b, 0x00, 0xc0, 0x48, 0x12, 0xdd, 0x00, 0x22, 0x49, 0x02, 0x00, 0xe0, 0x21, 0x0e, 0x60, 0xfb, 0x68, 0x00, 0x80, 0x48, 0x96, 0xd9, 0x00, 0x22, 0x49, 0x32, 0x00, 0xe0, 0x68, 0x0e, 0xc0, 0x06, 0x26, 0x00, 0x00, 0x47, 0xe2, 0x48, 0x00, 0x22, 0x49, 0x1c, 0x00, 0xe0, 0x2d, 0x0e, 0x8c, 0xfd, 0x33, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x0f, 0x0f, 0x08, 0x43, 0x1c, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x8f, 0x07, 0x10, 0x1e, 0x87, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xcf, 0x07, 0x30, 0xf8, 0xc1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xef, 0x03, 0xc0, 0x00, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x00, 0x80, 0x03, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char left[] U8X8_PROGMEM = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x0f, 0x00, 0x00, 0x00, 0xc0, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x00, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x00, 0xf0, 0x0f, 0x00, 0x80, 0x0f, 0x00, 0x80, 0x0f, 0x00, 0x80, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x80, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x80, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x80, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x80, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x80, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char right[] U8X8_PROGMEM = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x07, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x7f, 0x00, 0xc0, 0xff, 0xff, 0xff, 0xff, 0x07, 0xc0, 0xff, 0xff, 0xff, 0xff, 0x03, 0xc0, 0x01, 0x00, 0xc0, 0x3f, 0x00, 0xc0, 0x01, 0x00, 0xc0, 0x03, 0x00, 0xc0, 0x01, 0x00, 0x40, 0x00, 0x00, 0xc0, 0x01, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x01, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x01, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char warning[] U8X8_PROGMEM = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xef, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xcf, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0xcf, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x0f, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x2d, 0x0e, 0x00, 0x00, 0x8c, 0x11, 0x00, 0x00, 0x04, 0x00, 0x30, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x68, 0x0e, 0x00, 0x00, 0x8c, 0x11, 0x00, 0x00, 0x04, 0x00, 0x30, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x21, 0x0f, 0x00, 0x00, 0xc8, 0x11, 0x41, 0x20, 0x00, 0x01, 0x32, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x83, 0x0f, 0x00, 0x00, 0x48, 0x9b, 0xc7, 0xf9, 0xe4, 0xe3, 0x23, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x87, 0x0f, 0x00, 0x00, 0x48, 0xca, 0x4c, 0xc8, 0x64, 0x26, 0x22, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x87, 0x0f, 0x00, 0x00, 0x58, 0x0a, 0x4f, 0xc8, 0x64, 0x36, 0x22, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x03, 0x0f, 0x00, 0x00, 0x70, 0xce, 0x4d, 0xc8, 0x64, 0x36, 0x22, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x21, 0x0e, 0x00, 0x00, 0x30, 0x4e, 0x4c, 0xc8, 0x64, 0x26, 0x03, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x68, 0x0e, 0x00, 0x00, 0x30, 0xc4, 0x4f, 0xc8, 0x64, 0xe6, 0x33, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x2d, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x0f, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x03, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x8f, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xcf, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xef, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
const unsigned char meum[] U8X8_PROGMEM = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x8c, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x01, 0x00, 0x06, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xef, 0x03, 0x00, 0x06, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xcf, 0x07, 0x00, 0x04, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x8f, 0x07, 0x00, 0x8c, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x0f, 0x0f, 0x00, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x2d, 0x0e, 0x00, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x68, 0x0e, 0x00, 0x28, 0x00, 0x80, 0x31, 0x00, 0x00, 0x00, 0x63, 0x18, 0x00, 0x01, 0x00, 0xe0, 0x21, 0x0f, 0x00, 0x28, 0x00, 0x80, 0x31, 0x00, 0x00, 0x00, 0xe3, 0x18, 0x00, 0x01, 0x00, 0xe0, 0x83, 0x0f, 0x00, 0x28, 0x00, 0x80, 0x31, 0xc7, 0x93, 0x39, 0xe3, 0x9c, 0xe3, 0x31, 0x00, 0xe0, 0x87, 0x0f, 0x00, 0x38, 0x00, 0x80, 0x2b, 0x49, 0x92, 0x65, 0xa3, 0xd4, 0xa4, 0x49, 0x00, 0xe0, 0x87, 0x0f, 0x00, 0x1c, 0x00, 0x80, 0x2a, 0x4e, 0x92, 0x71, 0xa3, 0x54, 0x14, 0x7d, 0x00, 0xe0, 0x03, 0x0f, 0x00, 0x36, 0x00, 0x80, 0x2e, 0x49, 0x92, 0x4d, 0x63, 0x53, 0x14, 0x0d, 0x00, 0xe0, 0x21, 0x0e, 0xc0, 0xf7, 0x01, 0x80, 0xa4, 0x49, 0x92, 0x65, 0x63, 0xdb, 0xa6, 0x49, 0x00, 0xe0, 0x68, 0x0e, 0xb0, 0x77, 0x03, 0x80, 0x24, 0x4f, 0x62, 0x58, 0x00, 0x82, 0x43, 0x31, 0x00, 0xe0, 0x2d, 0x0e, 0xd8, 0xd6, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x0f, 0x0f, 0x6c, 0x3f, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x8f, 0x07, 0x24, 0x21, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xcf, 0x07, 0x24, 0x33, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xef, 0x03, 0x64, 0x9c, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x00, 0xc8, 0xe3, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x3f, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
int Tone[] = { B4, B4, B4, B4, B4, B4,
               B4, D5, G4, A4, B4,
               C5, C5, C5, C5, C5, B4, B4, B4,
               D5, D5, C5, A4, G4, G5 };
void Music() {
  ledcWriteTone(4, 392);
  delay(300);
  ledcWriteTone(4, 0);
  ledcWriteTone(4, 440);
  delay(300);
  ledcWriteTone(4, 0);
  ledcWriteTone(4, 494);
  delay(300);
  ledcWriteTone(4, 0);
  ledcWriteTone(4, 523);
  delay(300);
  ledcWriteTone(4, 0);
  ledcWriteTone(4, 587);
  delay(300);
  ledcWriteTone(4, 0);
  ledcWriteTone(4, 659);
  delay(300);
  ledcWriteTone(4, 0);
  ledcWriteTone(4, 698);
  delay(300);
  ledcWriteTone(4, 0);
}

//Callback function when not connected -- - 19 footlight flashing
void callback1()  //Callback function
{
  ledcWriteTone(4, Tone[3]);
  digitalWrite(19, HIGH);  //Extinguish
  delay(200);
  digitalWrite(19, LOW);  //Bright
  ledcWrite(4, 0);
}

void callback_disconecting()  //Callback function
{
  u8g2.firstPage();
  do {
    u8g2.drawXBM(45, 0, 48, 32, disconecting);
  } while (u8g2.nextPage());
}

void callback_conecting()  //Callback function
{
  u8g2.firstPage();
  do {
    u8g2.drawXBM(45, 0, 48, 32, conecting);
  } while (u8g2.nextPage());
}

//Push the joystick forward to display the picture
void callback_go()  //Callback function
{
  u8g2.firstPage();
  do {
    u8g2.drawXBM(45, 5, 32, 32, go);
  } while (u8g2.nextPage());
}

void callback_meum()  //Callback function
{
  u8g2.firstPage();
  do {
    u8g2.drawXBM(0, 0, 128, 32, meum);
  } while (u8g2.nextPage());
}

//Push the rocker backward to display the picture
void callback_turn()  //Callback function
{
  u8g2.firstPage();
  do {
    u8g2.drawXBM(45, 5, 32, 32, turn);
  } while (u8g2.nextPage());
}

void callback_X()  //Callback function
{
  u8g2.firstPage();
  do {
    u8g2.drawXBM(40, 5, 48, 32, right);
  } while (u8g2.nextPage());
}

void callback_x()  //Callback function
{
  u8g2.firstPage();
  do {
    u8g2.drawXBM(40, 5, 48, 32, left);
  } while (u8g2.nextPage());
}

void callback_A()  //Callback function
{
  u8g2.firstPage();
  do {
    u8g2.drawXBM(0, 0, 96, 32, AA);
    u8g2.drawStr(96, 30, Distance.c_str());
  } while (u8g2.nextPage());
}

void callback_B()  //Callback function
{
  u8g2.firstPage();
  do {
    u8g2.drawXBM(0, 0, 128, 32, BB);
  } while (u8g2.nextPage());
}

void callback_C()  //Callback function
{
  u8g2.firstPage();
  do {
    u8g2.drawXBM(0, 0, 128, 32, CC);
  } while (u8g2.nextPage());
}

void callback_D()  //Callback function
{
  u8g2.firstPage();
  do {
    u8g2.drawXBM(0, 0, 128, 32, DD);
  } while (u8g2.nextPage());
}

void callback_warning()  //Callback function
{
  u8g2.firstPage();
  do {
    u8g2.drawXBM(0, 0, 128, 32, warning);
  } while (u8g2.nextPage());
}

void buzzer()  //Callback function
{
  ledcWriteTone(4, Tone[3]);
}

void buzzer_close()  //Callback function
{
  ledcWrite(4, 0);  //Turn off the buzzer
}

void Open()  //Callback function
{
  digitalWrite(7, HIGH);
}

void Close()  //Callback function
{
  digitalWrite(7, LOW);
}

//Close all tasks
void Close_task() {
  if (ticker1.active() == true) {
    ticker1.detach();
  }
  if (ticker_Y.active() == true) {
    ticker_Y.detach();
  }
  if (ticker_meum.active() == true) {
    ticker_meum.detach();
  }
  if (ticker_warning.active() == true) {
    ticker_warning.detach();
  }
  if (ticker_y.active() == true) {
    ticker_y.detach();
  }
  if (ticker_X.active() == true) {
    ticker_X.detach();
  }
  if (ticker_x.active() == true) {
    ticker_x.detach();
  }
  if (ticker_A.active() == true) {
    ticker_A.detach();
  }
  if (ticker_B.active() == true) {
    ticker_B.detach();
  }
  if (ticker_C.active() == true) {
    ticker_C.detach();
  }
  if (ticker_D.active() == true) {
    ticker_D.detach();
  }
  if (ticker_buzzer.active() == true) {
    ticker_buzzer.detach();
  }
  if (ticker_disconecting.active() == true) {
    ticker_disconecting.detach();
  }
  if (ticker_conecting.active() == true) {
    ticker_conecting.detach();
  }
  if (OPEN.active() == true) {
    OPEN.detach();
  }
  if (CLOSE.active() == true) {
    CLOSE.detach();
  }
  if (ticker_buzzer_close.active() == true) {
    ticker_buzzer_close.detach();
  }
}

//Whether the connection is successful (callback function)
class MyServerCallbacks : public BLEServerCallbacks {
  void onConnect(BLEServer* pServer) {
    Serial.println("Now there is equipment access~");
    if (ticker1.active() == true) {
      ticker1.detach();
    }

    //OLED
    u8g2.firstPage();
    do {
      u8g2.drawXBM(45, 0, 48, 32, conecting);
    } while (u8g2.nextPage());
    //Vibrator
    digitalWrite(7, HIGH);
    digitalWrite(19, LOW);  
    delay(200);
    digitalWrite(7, LOW);

    //Play music
    Music();
    //OLED
    u8g2.firstPage();
    do {
      u8g2.drawXBM(0, 0, 128, 32, meum);
    } while (u8g2.nextPage());


    deviceConnected = true;         //If there is a device connection
    BLEDevice::startAdvertising();  //Start broadcasting
  };


  void onDisconnect(BLEServer* pServer) {  //If no equipment
    Serial.println("There is a device disconnected~");
    Close_task();  //Close all tasks
    ticker1.attach(1.5, callback1);
    //Buzzer
    ledcWriteTone(4, Tone[3]);
    //Vibrator
    digitalWrite(7, HIGH);
    delay(250);
    digitalWrite(7, LOW);
    delay(100);
    digitalWrite(7, HIGH);
    delay(250);
    digitalWrite(7, LOW);
    ledcWrite(4, 0);
    //OLED
    u8g2.firstPage();
    do {
      u8g2.drawXBM(45, 0, 48, 32, disconecting);
    } while (u8g2.nextPage());

    deviceConnected = false;
    BLEDevice::startAdvertising();  //Start broadcasting
  }
};



void setup() {
  Serial.begin(115200);  //Serial port initialization
  //Left and right buttons
  pinMode(8, INPUT);
  pinMode(10, INPUT);
  //Rocker
  pinMode(18, INPUT_PULLUP);
  //optional feature
  pinMode(19, OUTPUT);
  digitalWrite(19, HIGH);        
  ticker1.attach(1, callback1);  //Bluetooth prompt light on / off (flashing task)
  //Vibrator
  pinMode(7, OUTPUT);
  //Buzzer
  pinMode(6, OUTPUT);
  ledcSetup(4, 5000, 8);
  ledcAttachPin(6, 4);
  //OLED
  u8g2.begin();
  u8g2.enableUTF8Print();  // enable UTF8 support for the Arduino print() function
  u8g2.setFont(u8g2_font_ncenB14_tr);
  u8g2.setFontDirection(0);
  for (int i = 128; i > -90; i -= 14) {
    u8g2.firstPage();
    do {
      u8g2.drawStr(i, 25, "Joystick For CrowBot");
      delay(4);
    } while (u8g2.nextPage());
  }

  //delay(100);
  u8g2.firstPage();
  do {
    u8g2.drawXBM(45, 0, 48, 32, disconecting);
  } while (u8g2.nextPage());



  // Create the BLE Device
  BLEDevice::init("ESP32");  //BLE Device initialization, name esp32

  BLEDevice::setPower(ESP_PWR_LVL_P9);  //Set transmission frequency

  // Create the BLE Server
  pServer = BLEDevice::createServer();             //Create Server
  pServer->setCallbacks(new MyServerCallbacks());  //Set anonymous callback function（Instantiate MyServerCallbacks）

  // Create the BLE Service
  pService = pServer->createService(SERVICE_UUID);  //Create BLE Service

  // Create a BLE Characteristic
  pCharacteristic = pService->createCharacteristic(  //Create ble feature（Characterristic_UUID）
    CHARACTERISTIC_UUID,
    BLECharacteristic::PROPERTY_READ | BLECharacteristic::PROPERTY_WRITE | BLECharacteristic::PROPERTY_NOTIFY);
  pCharacteristic2 = pService->createCharacteristic(  //Create ble feature（Characterristic_UUID）
    RECV_UUID,
    BLECharacteristic::PROPERTY_READ | BLECharacteristic::PROPERTY_WRITE | BLECharacteristic::PROPERTY_NOTIFY);
  pCharacteristic3 = pService->createCharacteristic(  //Create ble feature（Characterristic_UUID）
    WARN_UUID,
    BLECharacteristic::PROPERTY_READ | BLECharacteristic::PROPERTY_WRITE | BLECharacteristic::PROPERTY_NOTIFY);
  pCharacteristic2->setValue(" ");

  pService->start();  //Service startup

 
  pAdvertising = BLEDevice::getAdvertising();  //A bleadvertising class pointer padvertising is defined, which points to bledevice:: getadvertising()
  pAdvertising->addServiceUUID(SERVICE_UUID);
  BLEDevice::startAdvertising();  //Start broadcasting
  Serial.println("Wait for a client to connect to notify...");
}



void loop() {

  //******************************************************Connect the Bluetooth program**************************************************************

  while (First == 0) {
    //    Serial.println(" ");
    //    Serial.print("Y：");
    //    Serial.println(Y);
    //    Serial.print("X：");
    //    Serial.println(X);

    if (deviceConnected) {  //If the device is connected
      A = analogRead(0);    //4 ADC keys
      Bb[i] = A;
      i++;
      delay(1);
      if (i == 10) {
        i = 0;
        flag = 1;
      }
      X = analogRead(1);    //rocker
      Y = analogRead(3);    //rocker
      L = digitalRead(8);   //Left button
      R = digitalRead(10);  //Right button
      I = digitalRead(18);  //Press the rocker
      //        Value = pCharacteristic->getValue();
      //        Serial.print("Value: ");
      //        Serial.println(Value.c_str());

      //********************************Left and right buttons**************************************
      if (L == 0) {
        pCharacteristic->setValue("L");
        Serial.println("L");
        direction = 'L';
        delay(20);
      }

      if (R == 0) {
        pCharacteristic->setValue("R");
        Serial.println("R");
        direction = 'R';
        delay(1);
      }

      //********************************Rocker press**************************************
      if (I == 0) {
        pCharacteristic->setValue("I");
        direction = 'I';
        delay(6);
      }

      //********************************Four buttons**************************************
      if (flag == 1 && button_Flag == 0) {
        if (((Bb[0] - Bb[1]) < 170) && ((Bb[1] - Bb[2]) < 170) && ((Bb[2] - Bb[3]) < 170) && ((Bb[3] - Bb[4]) < 170) && ((Bb[4] - Bb[5]) < 170) && ((Bb[5] - Bb[6]) < 170) && ((Bb[6] - Bb[7]) < 170)) {

          A = Bb[4];
          Serial.println("A:");
          Serial.println(A);


          if (A > 2800 && A < 3500) {
            pCharacteristic->setValue("C");  //Key C ------ light seeking
            if (buzzer_Flag == 0) {
              Close_task();
              u8g2.firstPage();
              do {
                u8g2.drawXBM(0, 0, 128, 32, CC);
              } while (u8g2.nextPage());
              ticker_buzzer.once_ms(0, buzzer);
              ticker_buzzer_close.once_ms(300, buzzer_close);
              buzzer_Flag = 1;
            }
            Close_Flag = 1;
            while (Close_Flag == 1) {
              I = digitalRead(18);  //Press the rocker
              delay(5);
              if (I == 0) {
                pCharacteristic->setValue("I");
                Close_Flag = 0;
                break;
              }
              L = digitalRead(8);   //Left button
              R = digitalRead(10);  //Right button
              if (L == 0) {
                pCharacteristic->setValue("L");
                Serial.println("L");
                delay(20);
                pCharacteristic->setValue("Q");
              }
              if (R == 0) {
                pCharacteristic->setValue("R");
                Serial.println("R");
                delay(10);
                pCharacteristic->setValue("Q");
              }
            }
            I = digitalRead(18);  //Press the rocker
            if (I == 0) {
              buzzer_Flag = 0;
              pCharacteristic->setValue("I");
              delay(150);
              ticker_meum.once_ms(0, callback_meum);
              Close_Flag = 0;
            }
          }



          if ((A > 2100) && (A < 2800)) {
            pCharacteristic->setValue("A");  //Key A ----- obstacle avoidance
            if (buzzer_Flag == 0) {
              Close_task();
              ticker_buzzer.once_ms(0, buzzer);
              ticker_buzzer_close.once_ms(300, buzzer_close);
              buzzer_Flag = 1;
            }
            Close_Flag = 1;
            while (Close_Flag == 1) {
              I = digitalRead(18);  //Press the rocker
              delay(5);
              if (I == 0) {
                digitalWrite(7, LOW);
                pCharacteristic->setValue("I");
                Close_Flag = 0;
                break;
              }
              Distance = pCharacteristic2->getValue();
              Warning = pCharacteristic3->getValue();
              Serial.print("Its distance is: ");
              Serial.println(Distance.c_str());
              R = digitalRead(10);  //Right button
              if (R == 0) {
                pCharacteristic->setValue("R");
                Serial.println("R");
                delay(40);
                pCharacteristic->setValue("Q");
              }
              if (Warning == "S") {
                ticker_warning.once_ms(0, callback_warning);
                digitalWrite(7, HIGH);
                delay(150);
                I = digitalRead(18);  //Press the rocker
                if (I == 0) {
                  pCharacteristic->setValue("I");
                  Close_Flag = 0;
                  break;
                }
                digitalWrite(7, LOW);
                delay(150);
              } else {
                ticker_A.once_ms(0, callback_A);
              }
            }
            I = digitalRead(18);  //Press the rocker
            if (I == 0) {
              digitalWrite(7, LOW);
              buzzer_Flag = 0;
              pCharacteristic->setValue("I");
              delay(150);
              ticker_meum.once_ms(0, callback_meum);
              Close_Flag = 0;
            }
          }





          if (A < 70) {
            pCharacteristic->setValue("B");  //Key B ------ line patrol
            if (buzzer_Flag == 0) {
              Close_task();
              u8g2.firstPage();
              do {
                u8g2.drawXBM(0, 0, 128, 32, BB);
              } while (u8g2.nextPage());
              ticker_buzzer.once_ms(0, buzzer);
              ticker_buzzer_close.once_ms(300, buzzer_close);
              buzzer_Flag = 1;
            }
            Close_Flag = 1;
            while (Close_Flag == 1) {
              I = digitalRead(18);
              delay(5);
              if (I == 0) {
                pCharacteristic->setValue("I");
                Close_Flag = 0;
                break;
              }
              L = digitalRead(8);   //Left button
              R = digitalRead(10);  //Right button
              if (L == 0) {
                pCharacteristic->setValue("L");
                Serial.println("L");
                delay(20);
                pCharacteristic->setValue("Q");
              }
              if (R == 0) {
                pCharacteristic->setValue("R");
                Serial.println("R");
                delay(10);
                pCharacteristic->setValue("Q");
              }
            }
            I = digitalRead(18);  //Press the rocker
            if (I == 0) {
              buzzer_Flag = 0;
              pCharacteristic->setValue("I");
              delay(150);
              ticker_meum.once_ms(0, callback_meum);
              Close_Flag = 0;
            }
          }






          if (A > 600 && A < 1000) {
            pCharacteristic->setValue("D");  //Key D --- singing and flashing
            if (buzzer_Flag == 0) {
              Close_task();
              u8g2.firstPage();
              do {
                u8g2.drawXBM(0, 0, 128, 32, DD);
              } while (u8g2.nextPage());
              ticker_buzzer.once_ms(0, buzzer);
              ticker_buzzer_close.once_ms(300, buzzer_close);
              buzzer_Flag = 1;
            }
            Close_Flag = 1;
            while (Close_Flag == 1) {
              I = digitalRead(18);
              delay(5);
              if (I == 0) {
                pCharacteristic->setValue("I");
                Close_Flag = 0;
                break;
              }
            }
            I = digitalRead(18);  //Press the rocker
            if (I == 0) {
              buzzer_Flag = 0;
              pCharacteristic->setValue("I");
              delay(120);
              ticker_meum.once_ms(0, callback_meum);
              Close_Flag = 0;
            }
          }
        }


        flag = 0;
      }
      //********************************rocker**************************************
      if (Y > 3700 && X > 2000 && X < 2500)  //In Y direction
      {
        direction = 'Y';
      } else if (Y < 500 && X > 2000 && X < 2500)  //In y direction
      {
        direction = 'y';
      }

      if (X < 1300 && Y > 1900 && Y < 2400)  //In X direction
      {
        direction = 'X';
      } else if (X > 3200 && Y > 1800 && Y < 2400)  //In x direction
      {
        direction = 'x';
      }

      if (X < 1500 && Y > 3000)  //In XY direction
      {
        direction = 'a';
      } else if (X < 1750 && Y < 900)  //In Xy direction
      {
        direction = 'b';
      } else if (X > 2700 && Y < 800)  //In xy direction
      {
        direction = 'c';
      } else if (X > 3000 && Y > 3500)  //In xY direction
      {
        direction = 'd';
      }


      switch (direction) {
        case 'Y':
          if (shock_Flag == 1) {
            OPEN.once_ms(0, Open);
            CLOSE.once_ms(150, Close);
            shock_Flag = 0;
            turn_Flag = 1;
            button_Flag = 1;
          }
          pCharacteristic->setValue("Y");  //Set value
          if (Y_Flag == 0) {
            ticker_Y.once_ms(0, callback_go);
            Y_Flag = 1;
            y_Flag = 0;
            X_Flag = 0;
            x_Flag = 0;
          }
          Flag = 1;
          break;
        case 'y':
          if (shock_Flag == 1) {
            OPEN.once_ms(0, Open);
            CLOSE.once_ms(150, Close);
            shock_Flag = 0;
            turn_Flag = 1;
            button_Flag = 1;
          }
          pCharacteristic->setValue("y");  //Set value
          if (y_Flag == 0) {
            ticker_y.once_ms(0, callback_turn);
            Y_Flag = 0;
            y_Flag = 1;
            X_Flag = 0;
            x_Flag = 0;
          }
          Flag = 1;
          break;
        case 'X':
          if (shock_Flag == 1 || turn_Flag == 1) {
            OPEN.once_ms(0, Open);
            CLOSE.once_ms(150, Close);
            shock_Flag = 0;
            turn_Flag = 0;
            button_Flag = 1;
          }
          pCharacteristic->setValue("X");  //Set value
          if (X_Flag == 0) {
            ticker_X.once_ms(0, callback_X);
            Y_Flag = 0;
            y_Flag = 0;
            X_Flag = 1;
            x_Flag = 0;
          }

          Flag = 1;
          break;
        case 'x':
          if (shock_Flag == 1 || turn_Flag == 1) {
            OPEN.once_ms(0, Open);
            CLOSE.once_ms(150, Close);
            shock_Flag = 0;
            turn_Flag = 0;
            button_Flag = 1;
          }
          pCharacteristic->setValue("x");  //Set value
          if (x_Flag == 0) {
            ticker_x.once_ms(0, callback_x);
            Y_Flag = 0;
            y_Flag = 0;
            X_Flag = 0;
            x_Flag = 1;
          }
          Flag = 1;
          break;
        case 'a':
          if (shock_Flag == 1) {
            OPEN.once_ms(0, Open);
            CLOSE.once_ms(150, Close);
            shock_Flag = 0;
            turn_Flag = 1;
            button_Flag = 1;
          }
          pCharacteristic->setValue("XY");  //Set value
          Flag = 1;
          break;
        case 'b':
          if (shock_Flag == 1) {
            OPEN.once_ms(0, Open);
            CLOSE.once_ms(150, Close);
            shock_Flag = 0;
            turn_Flag = 1;
            button_Flag = 1;
          }
          pCharacteristic->setValue("Xy");  //Set value
          Flag = 1;
          break;
        case 'c':
          if (shock_Flag == 1) {
            OPEN.once_ms(0, Open);
            CLOSE.once_ms(150, Close);
            shock_Flag = 0;
            turn_Flag = 1;
            button_Flag = 1;
          }
          pCharacteristic->setValue("xy");  //Set value
          Flag = 1;
          break;
        case 'd':
          if (shock_Flag == 1) {
            OPEN.once_ms(0, Open);
            CLOSE.once_ms(150, Close);
            shock_Flag = 0;
            turn_Flag = 1;
            button_Flag = 1;
          }
          pCharacteristic->setValue("xY");  //Set value
          Flag = 1;
          break;
        case 'Q':
          pCharacteristic->setValue("Q");  //Set value
          delay(10);
          break;
      }
      if (Y > 2100 && Y < 2500 && X > 2100 && X < 2500 && Flag == 1)  //stop
      {
        Close_task();
        pCharacteristic->setValue("N");
        shock_Flag = 1;
        turn_Flag = 1;
        button_Flag = 0;
        Y_Flag = 0;
        y_Flag = 0;
        X_Flag = 0;
        x_Flag = 0;
        Flag = 0;
        ticker_meum.once_ms(3, callback_meum);
        delay(260);
      }

      direction = 'Q';


    } else if (!deviceConnected) {
      delay(500);  //give the bluetooth stack the chance to get things ready
    }
  }
}
